import Data.Array.Diff
import Data.List  (find)
import Data.Maybe (isJust, fromJust)

type Knoten         = Int
type AdjListe e     = DiffArray Knoten [(Knoten, e)]
newtype ListGraph e = G (AdjListe e)

adj :: Knoten -> Knoten -> ListGraph e -> Bool
adj u v (G arr) = elem v $ map fst (arr!u)

adjL :: Knoten -> ListGraph e -> [(Knoten,e)]
adjL u (G arr) = arr!u

label :: Knoten -> Knoten -> ListGraph e -> Maybe e
label u v (G arr) = case (find (\(v',_) -> v==v') (arr!u)) of
	Nothing -> Nothing      
	Just x  -> Just (snd x) 

setLabel :: e -> Knoten -> Knoten -> ListGraph e -> ListGraph e
setLabel l u v (G arr) = G (arr//[(u,list)]) where
    list = foldr update [] (arr!u)
    update n@(v',_) r 
        | v' == v = (v',l):r
        | otherwise = n:r

anzKnoten (G arr) = snd.bounds $ arr

istLeer g = 0 == anzKnoten g

knoten :: ListGraph e -> [Knoten]
knoten (G arr) = indices arr

kanten :: ListGraph e -> [Kante e]
kanten g = concatMap (\k -> map (\(n,e) -> ((k,n),e)) (adjL k g)) (knoten g)
		