class SuchStrukt a where
    naechstes :: a b -> (b,a b)
    fuegEin   :: [b] -> a b -> a b
    istLeer   :: a b -> Bool

newtype Stack e = S [e]

instance SuchStrukt Stack where
    naechstes (S (x:xs)) = (x,S xs)
    fuegEin l (S xs)     = S (l++xs)
    istLeer (S [])       = True
    istLeer _            = False

instance SuchStrukt Q.Queue where
    naechstes            = Q.dequeue
    fuegEin l q          = foldr Q.enqueue q l
    istLeer              = Q.null

traverse :: (SuchStrukt a) => G.ListGraph e  -> a (G.Knoten,e) -> G.Knoten -> [G.Knoten]
traverse g todo start = 
    start:traverse' (fuegEin (G.adjL start g) todo) (S.insert start S.empty) 
    where
        traverse' todo besucht = 
            let naechstes = getNaechstes todo besucht in case naechstes of
                Nothing -> []
                Just (node,todo') -> 
                    node : traverse' 
                        (fuegEin (G.adjL node g) todo') 
                        (S.insert node besucht)traverse g todo start = 
                     start:traverse' (fuegEin (G.adjL start g) todo) 
                                     (S.insert start S.empty) where
        getNaechstes todo besucht
            | istLeer todo       = Nothing
            | S.member n besucht = getNaechstes todo' besucht
            | otherwise          = Just (n,todo') where
                ((n,_),todo') = naechstes todo

exampleGraph = G.erzeug [1..5] kanten where
kanten = concat [[((n,m),w),((m,n),w)] | ((n,m),w) <- 
         [((1,2),1), ((1,3),1), ((1,4),1), ((2,5),1), 
          ((2,3),1), ((3,4),1), ((3,5),1), ((4,5),1)]]
				